Bug 1317010 - CVE-2016-3138 CVE-2016-3139 CVE-2016-3140 CVE-2016-3137 CVE-2016-3136 CVE-2016-2184 CVE-2016-2185 CVE-2016-2186 CVE-2016-2187 CVE-2016-2188 kernel: various crashes on invalid usb device descriptors [fedora-all]
CVE-2016-3138 CVE-2016-3139 CVE-2016-3140 CVE-2016-3137 CVE-2016-3136 CVE-201...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
23
All Linux
low Severity low
: ---
: ---
Assigned To: Kernel Maintainer List
Fedora Extras Quality Assurance
: Reopened, Security, SecurityTracking
Depends On:
Blocks: CVE-2016-3138 CVE-2016-3139 CVE-2016-3140 CVE-2016-3137 CVE-2016-3136 CVE-2016-2184 CVE-2016-2185 CVE-2016-2186 CVE-2016-2187 CVE-2016-2188
  Show dependency treegraph
 
Reported: 2016-03-11 12:03 EST by Adam Mariš
Modified: 2016-05-16 10:10 EDT (History)
9 users (show)

See Also:
Fixed In Version: kernel-4.5.0-302.fc24 kernel-4.4.6-301.fc23
Doc Type: Release Note
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-04-01 20:46:32 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Adam Mariš 2016-03-11 12:03:34 EST
This is an automatically created tracking bug!  It was created to ensure
that one or more security vulnerabilities are fixed in affected versions
of Fedora.

For comments that are specific to the vulnerability please use bugs filed
against the "Security Response" product referenced in the "Blocks" field.

For more information see:
http://fedoraproject.org/wiki/Security/TrackingBugs

When submitting as an update, use the fedpkg template provided in the next
comment(s).  This will include the bug IDs of this tracking bug as well as
the relevant top-level CVE bugs.

Please also mention the CVE IDs being fixed in the RPM changelog and the
fedpkg commit message.

NOTE: this issue affects multiple supported versions of Fedora. While only
one tracking bug has been filed, please correct all affected versions at
the same time.  If you need to fix the versions independent of each other,
you may clone this bug as appropriate.

Reproducers, if any, will remain confidential and never be made public, unless done so by the security team.

[bug automatically created by: add-tracking-bugs]
Comment 1 Adam Mariš 2016-03-11 12:03:48 EST
Use the following template to for the 'fedpkg update' request to submit an
update for this issue as it contains the top-level parent bug(s) as well as
this tracking bug.  This will ensure that all associated bugs get updated
when new packages are pushed to stable.

=====

# bugfix, security, enhancement, newpackage (required)
type=security

# testing, stable
request=testing

# Bug numbers: 1234,9876
bugs=1316204,1316996,1316995,1316993,1317007,1317010

# Description of your update
notes=Security fix for 

# Enable request automation based on the stable/unstable karma thresholds
autokarma=True
stable_karma=3
unstable_karma=-3

# Automatically close bugs when this marked as stable
close_bugs=True

# Suggest that users restart after update
suggest_reboot=False

======

Additionally, you may opt to use the bodhi web interface to submit updates:

https://bodhi.fedoraproject.org/updates/new
Comment 2 Vladis Dronov 2016-03-15 06:36:11 EDT
the upstream driver (and so Fedora's one) was rebased and does not have this bug, so this bug is rhel7-only. the fix is to check the number of endpoints (as it was done in [aiptek] driver fix at http://www.spinics.net/lists/linux-input/msg42294.html, [aiptek] was based on [wacom]). rhel7 patch is attached to the related: bz1283375, bz1283377. closing this as notabug.
Comment 3 Josh Boyer 2016-03-15 08:55:54 EDT
(In reply to Vladis Dronov from comment #2)
> the upstream driver (and so Fedora's one) was rebased and does not have this
> bug, so this bug is rhel7-only. the fix is to check the number of endpoints
> (as it was done in [aiptek] driver fix at
> http://www.spinics.net/lists/linux-input/msg42294.html, [aiptek] was based
> on [wacom]). rhel7 patch is attached to the related: bz1283375, bz1283377.
> closing this as notabug.

Reopening, since this bug is tracking 4 other CVEs.
Comment 4 Josh Boyer 2016-03-15 15:40:07 EDT
Patch sent upstream for CVE-2016-3138: http://marc.info/?l=linux-usb&m=145803342320160&w=2

Patch sent upstream for CVE-2016-3140: http://marc.info/?l=linux-usb&m=145796765030590&w=2
Comment 5 Josh Boyer 2016-03-16 09:30:34 EDT
Patch sent upstream for CVE-2016-3136: http://marc.info/?l=linux-usb&m=145813478817704&w=2
Comment 6 Josh Boyer 2016-03-16 12:01:42 EDT
Patch sent upstream for CVE-2016-3137: http://marc.info/?l=linux-usb&m=145813816318926&w=2
Comment 9 Josh Boyer 2016-03-18 11:08:47 EDT
CVE-2016-3137, CVE-2016-3138, CVE-2016-3140 fixed in Fedora git on all branches.

All CVEs mentioned in this bug are fixed except CVE-2016-3136.  That has a patch submitted, but upstream asked for some changes.
Comment 10 Vladis Dronov 2016-03-18 12:09:48 EDT
hello, Josh,
we have more bugs like these (crash on invalid usb descriptors), i'm not sure why this bz was not linked to them. i do not want to create more fedora-all bzs, so i will link the rest bzs also:

CVE-2016-2184 kernel: Kernel panic on invalid USB device descriptor (snd_usb_audio driver) bz1317012
CVE-2016-2185 kernel: Kernel panic on invalid USB device descriptor (ati_remote2 driver) bz1317014
CVE-2016-2186 kernel: Kernel panic on invalid USB device descriptor (powermate driver) bz1317015
CVE-2016-2187 kernel: Kernel panic on invalid USB device descriptor (gtco driver) bz1317017
CVE-2016-2188 kernel: Kernel panic on invalid USB device descriptor (iowarrior driver) bz1317018
Comment 11 Josh Boyer 2016-03-18 12:17:42 EDT
(In reply to Vladis Dronov from comment #10)
> hello, Josh,
> we have more bugs like these (crash on invalid usb descriptors), i'm not
> sure why this bz was not linked to them. i do not want to create more
> fedora-all bzs, so i will link the rest bzs also:
> 
> CVE-2016-2184 kernel: Kernel panic on invalid USB device descriptor
> (snd_usb_audio driver) bz1317012
> CVE-2016-2185 kernel: Kernel panic on invalid USB device descriptor
> (ati_remote2 driver) bz1317014
> CVE-2016-2186 kernel: Kernel panic on invalid USB device descriptor
> (powermate driver) bz1317015
> CVE-2016-2187 kernel: Kernel panic on invalid USB device descriptor (gtco
> driver) bz1317017
> CVE-2016-2188 kernel: Kernel panic on invalid USB device descriptor
> (iowarrior driver) bz1317018

Four of these all already have fedora-all bugs for them and are all fixed.  They are, respectively:

bug 1317470 snd_usb_audio_driver
bug 1317471 ati_remote2
bug 1317464 powermate
bug 1317467 iowarrior

That leaves CVE-2016-3136 (mct_u232 driver) and CVE-2016-2187 (gtco driver) left to track in this bug.
Comment 12 Vladis Dronov 2016-03-21 04:40:27 EDT
Thank you. I've posted a patch for CVE-2016-2187 (gtco driver) to the linux-usb@ and linux-input@ lists:

http://www.spinics.net/lists/linux-usb/msg137950.html
http://www.spinics.net/lists/linux-input/msg43786.html

A patch for CVE-2016-3136 (mct_u232 driver) was written and posted by Oliver:

http://marc.info/?l=linux-usb&m=145813478817704&w=2
http://www.spinics.net/lists/linux-usb/msg137789.html
Comment 13 Josh Boyer 2016-03-21 07:52:54 EDT
(In reply to Vladis Dronov from comment #12)
> Thank you. I've posted a patch for CVE-2016-2187 (gtco driver) to the
> linux-usb@ and linux-input@ lists:
> 
> http://www.spinics.net/lists/linux-usb/msg137950.html
> http://www.spinics.net/lists/linux-input/msg43786.html

Thanks.

> A patch for CVE-2016-3136 (mct_u232 driver) was written and posted by Oliver:
> 
> http://marc.info/?l=linux-usb&m=145813478817704&w=2
> http://www.spinics.net/lists/linux-usb/msg137789.html

Right, I linked to that above.  Changes were requested from upstream as the patch isn't sufficient.
Comment 14 Josh Boyer 2016-03-22 14:13:15 EDT
I've updated Fedora git to use the revised upstream patch (v2) for CVE-2016-3140:
http://marc.info/?l=linux-usb&m=145857226802981&w=2
Comment 15 Josh Boyer 2016-03-22 14:21:37 EDT
I've added Vladis' patch for CVE-2016-2187 to all branches in Fedora git.
Comment 16 Josh Boyer 2016-03-22 14:28:22 EDT
I've added v2 of the fix for CVE-2016-3136 to all branches in Fedora git:
http://marc.info/?l=linux-usb&m=145856609032572&w=2

That completes all CVEs tracked in this bug.
Comment 17 Fedora Update System 2016-03-31 00:05:22 EDT
kernel-4.5.0-302.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-81fd1b03aa
Comment 18 Fedora Update System 2016-03-31 11:58:00 EDT
kernel-4.4.6-301.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-7e602c0e5e
Comment 19 Fedora Update System 2016-03-31 12:01:52 EDT
kernel-4.4.6-201.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2016-ed5110c4bb
Comment 20 Fedora Update System 2016-03-31 21:55:25 EDT
kernel-4.4.6-201.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-ed5110c4bb
Comment 21 Fedora Update System 2016-04-01 11:22:46 EDT
kernel-4.4.6-301.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-7e602c0e5e
Comment 22 Fedora Update System 2016-04-01 16:56:45 EDT
kernel-4.5.0-302.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-81fd1b03aa
Comment 23 Fedora Update System 2016-04-01 20:42:50 EDT
kernel-4.5.0-302.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.
Comment 24 Fedora Update System 2016-04-02 11:50:39 EDT
kernel-4.5.0-302.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.
Comment 25 Fedora Update System 2016-04-08 11:51:39 EDT
kernel-4.4.6-301.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.
Comment 26 Fedora Update System 2016-04-08 16:19:22 EDT
kernel-4.4.6-201.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.